#ifndef __WFCENCRYPTDECRYPTTHREAD__
#define __WFCENCRYPTDECRYPTTHREAD__

#include <cryptlib/cryptlib.h>
#include <cryptlib/des.h>
#include <cryptlib/misc.h>
#include <cryptlib/filters.h>
#include <cryptlib/modes.h>
#include <cryptlib/md5.h>

#include "WFCUtil.h"
#include "WFC_Defines.h"

using namespace CryptoPP;

class WFCEncryptDecryptThread {


public:

	typedef unsigned char skey[KEYLEN];
	typedef unsigned char hash[HASH_SIZE];	//128 bit hash

public:
	WFCEncryptDecryptThread();
	~WFCEncryptDecryptThread();

	void init(bool encrypt, char* args[]);

	int GetProgress();

	int LastError();

	void GetLastErrorMessage(char* dest, int maxlen);

	void SetUpdateProgressBar(POINT* pos, HWND window);	//optionally draw progress bar in this window

	void UpdateProgress();

	void DoEncryptDecrypt();

private:

	//private functions

	void SetLastErrorMessage(char* msg);

	void CleanUp();

private:	

	//private data
	char* currentArgs[5];
	unsigned char curblock[BUFSZ], prevblock[BUFSZ], eblock[BUFSZ];

	DES_EDE3_Encryption *encryptor;
	DES_EDE3_Decryption *decryptor;

	MD5 md5;

	unsigned int progress;


	unsigned long eof;
	unsigned long dataWritten;

	hash checksum;
	hash fchecksum;

	skey tkey;

	bool encrypt;

	fstream infile;
	fstream outfile;

	char pad;

	int lastError;

	char* lastErrorMessage;

	HWND updateWin;
	POINT updateWinPos;
};


#endif